View Issue Details

IDProjectCategoryView StatusLast Update
0018585LazarusOtherpublic2011-12-01 11:25
ReporterPatrick ChevalleyAssigned ToMattias Gaertner 
PrioritynormalSeveritycrashReproducibilityalways
Status closedResolutionfixed 
Product Version0.9.29 (SVN)Product Build 
Target VersionFixed in Version 
Summary0018585: AggPas demo crash on 64bit
DescriptionBoth AggPas demo crash on Linux 64bit / Gtk2.
If work fine if compiled for 32bit.

Using fixes_0_9_30 branch at revision 29112

See gdb trace below.
Additional InformationProgram received signal SIGSEGV, Segmentation fault.
0x00000000007ad31c in QSORT_CELLS (START=0x7ffff7faf410, NUM=2) at ../src/agg_rasterizer_scanline_aa.pas:611
611 while cell_aa_ptr_ptr(ptrcomp(j ) + 1 * 4 )^^.x < j^.x do
(gdb) bt
#0 0x00000000007ad31c in QSORT_CELLS (START=0x7ffff7faf410, NUM=2) at ../src/agg_rasterizer_scanline_aa.pas:611
0000001 0x00000000007ad85d in SORT_CELLS (this=...) at ../src/agg_rasterizer_scanline_aa.pas:792
0000002 0x00000000007aecd2 in REWIND_SCANLINES (this=...) at ../src/agg_rasterizer_scanline_aa.pas:1570
0000003 0x00000000007d29c0 in RENDER_SCANLINES (RAS=0x7ffff7f711a0, SL=0x7ffff7f71170, REN=0x7ffff7f710d8)
    at ../src/agg_render_scanlines.pas:62
0000004 0x0000000000791cde in AGG2DRENDERER_RENDER (this=0x7ffff7f70b90, RENBASE=0x7ffff7f71038,
    RENSOLID=0x7ffff7f710d8, FILLCOLOR_=true, USEFONT=false) at ../src/agg_fpimage.pas:3129
0000005 0x000000000078a099 in RENDER (this=0x7ffff7f70b90, FILLCOLOR_=true, USEFONT=false)
    at ../src/agg_fpimage.pas:1092
0000006 0x000000000078d552 in AGGDRAWPATH (this=0x7ffff7f70b90, FLAG=AGG_FILLONLY, USEFONT=false)
    at ../src/agg_fpimage.pas:1835
0000007 0x000000000078b4a8 in DOELLIPSEFILL (this=0x7ffff7f70b90, BOUNDS=...) at ../src/agg_fpimage.pas:1365
0000008 0x00000000005a5425 in FPCANVAS_TFPCUSTOMCANVAS_$__DOELLIPSEANDFILL$TRECT ()
TagsNo tags attached.
Fixed in Revision29164
LazTarget-
WidgetsetGTK 2
Attached Files

Activities

Mattias Gaertner

2011-01-23 11:45

manager   ~0045419

I fixed the crash. Now there is an endless loop.
Strange thing is that many aggpas code contains changes for 64bit support, but many others don't. I'm not sure what is the state of the aggpas 64bit support. Probably someone has to check all the functions.

Issue History

Date Modified Username Field Change
2011-01-22 15:03 Patrick Chevalley New Issue
2011-01-22 15:03 Patrick Chevalley Widgetset => GTK 2
2011-01-23 11:45 Mattias Gaertner Fixed in Revision => 29164
2011-01-23 11:45 Mattias Gaertner LazTarget => -
2011-01-23 11:45 Mattias Gaertner Note Added: 0045419
2011-01-23 11:45 Mattias Gaertner Assigned To => Mattias Gaertner
2011-01-23 11:45 Mattias Gaertner Status new => resolved
2011-01-23 11:45 Mattias Gaertner Resolution open => fixed
2011-12-01 11:25 Marc Weustink Status resolved => closed